ImmutableASTTransformation (Groovy 5.0.8)
Description: declaration: package: org.codehaus.groovy.transform, class: ImmutableASTTransformation

Package org.codehaus.groovy.transform

# Class ImmutableASTTransformation

java.lang.Object
org.codehaus.groovy.transform.AbstractASTTransformation
org.codehaus.groovy.transform.ImmutableASTTransformation

All Implemented Interfaces:
  `CompilationUnitAware`, `ASTTransformation`, `ErrorCollecting`

public class ImmutableASTTransformation extends AbstractASTTransformation implements CompilationUnitAware
Handles generation of code for the @Immutable annotation.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `IMMUTABLE_BREADCRUMB`
  `static final ClassNode`
  `MY_TYPE`

  ### Fields inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

  `RETENTION_CLASSNODE, sourceUnit`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ImmutableASTTransformation()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Object`
  `checkImmutable(Class<?> clazz, String fieldName, Object field)`
  For compatibility with pre 2.5 compiled classes
  `static Object`
  `checkImmutable(Class<?> clazz, String fieldName, Object field, List<String> knownImmutableFieldNames, List<Class> knownImmutableClasses)`
  `static Object`
  `checkImmutable(String className, String fieldName, Object field)`
  This method exists to be binary compatible with 1.7 - 1.8.6 compiled code.
  `static void`
  `checkPropNames(Object instance, Map<String,Object> args)`
  Called during named-arguments constructor execution to check given names.
  `String`
  `getAnnotationName()`
  If the transform is associated with a single annotation, returns a name suitable for displaying in error messages.
  `void`
  `setCompilationUnit(CompilationUnit unit)`
  `void`
  `visit(ASTNode[] nodes, SourceUnit source)`
  The method is invoked when an AST Transformation is active.

  ### Methods inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

  `addError, checkIncludeExcludeUndefinedAware, checkIncludeExcludeUndefinedAware, checkNotInterface, checkPropertyList, checkPropertyList, checkPropertyList, copyAnnotatedNodeAnnotations, copyAnnotatedNodeAnnotations, deemedInternalName, getMemberClassList, getMemberClassValue, getMemberClassValue, getMemberIntValue, getMemberStringList, getMemberStringValue, getMemberStringValue, getMemberValue, hasAnnotation, init, memberHasValue, shouldSkip, shouldSkip, shouldSkipOnDescriptorUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, tokenize`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### MY_TYPE

    public static final ClassNode MY_TYPE

  - ### IMMUTABLE_BREADCRUMB

    public static final String IMMUTABLE_BREADCRUMB
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### ImmutableASTTransformation

    public ImmutableASTTransformation()

- ## Method Details

  - ### getAnnotationName

    public String getAnnotationName()
    Description copied from class: `AbstractASTTransformation`
    If the transform is associated with a single annotation, returns a name suitable for displaying in error messages.
    Overrides:
      `getAnnotationName` in class `AbstractASTTransformation`
    Returns:
      The simple name of the annotation including the "@" or null if no such name is defined

  - ### setCompilationUnit

    public void setCompilationUnit(CompilationUnit unit)
    Specified by:
      `setCompilationUnit` in interface `CompilationUnitAware`

  - ### visit

    public void visit(ASTNode[] nodes, SourceUnit source)
    Description copied from interface: `ASTTransformation`
    The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.
    Specified by:
      `visit` in interface `ASTTransformation`
    Parameters:
      `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
      `source` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.

  - ### checkImmutable

    public static Object checkImmutable(String className, String fieldName, Object field)
    This method exists to be binary compatible with 1.7 - 1.8.6 compiled code.

  - ### checkImmutable

    public static Object checkImmutable(Class<?> clazz, String fieldName, Object field)
    For compatibility with pre 2.5 compiled classes

  - ### checkImmutable

    public static Object checkImmutable(Class<?> clazz, String fieldName, Object field, List<String> knownImmutableFieldNames, List<Class> knownImmutableClasses)

  - ### checkPropNames

    public static void checkPropNames(Object instance, Map<String,Object> args)
    Called during named-arguments constructor execution to check given names.